using System;
using UnityEngine;
using System.Collections.Generic;
using System.Linq;
using MVR.FileManagementSecure;
using SimpleJSON;

namespace ky1001 {
    public class AddAtom : MVRScript {
		#region PluginInfo
        public string pluginAuthor = "ky1001";
        public string pluginName = "AddAtom";
        public string pluginVersion = "2.1";
        public string pluginDate = "2022-02-12";
        public string pluginDescription = "";
        #endregion
        
		#region Var
        private Atom AddedAtom;
        private Atom currentAtom;
        private Atom targetAtom;
        private UIDynamic spacer;
        private UIDynamic spacer3;
		private JSONStorableFloat maxD;
		private UIDynamicSlider smaxD;
		private JSONStorableBool cr_Bool;
        private UIDynamicToggle cr_Toggle;
		private JSONStorableBool ts_Bool;
        private UIDynamicToggle ts_Toggle;
		private JSONStorableBool ja_Bool;
        private UIDynamicToggle ja_Toggle;
		private JSONStorableBool abp_Bool;
        private UIDynamicToggle abp_Toggle;
		private JSONStorableBool mark_Bool;
        private UIDynamicToggle mark_Toggle;
		private JSONStorableBool kh_Bool;
        private UIDynamicToggle kh_Toggle;
        private Vector3 currentAtomPosition;
        private Vector3 targetAtomPosition;
        private UIDynamicButton dm_button;
        private UIDynamicButton dm2_button;
        private UIDynamicButton add_button;
        private UIDynamicButton bi_button;
        private UIDynamicButton col_button;
        private UIDynamicButton rfl_button;
        private JSONStorableStringChooser catJSON;
        private JSONStorableStringChooser itemJSON;
        private JSONStorableStringChooser targetJSON;
        private UIDynamicPopup dp1;
        private UIDynamicPopup dp2;
        private UIDynamicPopup dp3;
        private bool add;
        public List<List<string>> AtomList = new List<List<string>>();
        public List<string> CatList = new List<string>();
        protected JSONStorableString filename;
        private string iniFile;
        private string iniFilePath;

        private string str1;
        private string str2;
        private string str3;
        
		private GameObject line = null;
        private GameObject sphere = null;
        private GameObject sphereG = null;
        private Vector3 kh;
        private float mkSize = 0.5f;
        private bool mkUpDown = true;
        #endregion      

        //public string[] CatList = new string[]
        public string[] Items = new string[] {
            "Animation",
            //"Environments",
            //"FloorsAndWalls",
            "Force",
            //"Furniture",
            "Light",
            "Misc",
            //"People",
            //"Props",
            //"Reflective",
            //"Shapes",
            //"Sound",
            "Toys",
            "Triggers"
        };

        private const string loadExt = "json";
        private const string presetLoadPath = "Saves/PluginData/AddAtom";
        public string LoadData;

        public override void Init() {
            try {                
                cr_Bool = new JSONStorableBool("Bring It to Player", true);
                RegisterBool(cr_Bool);
                if (containingAtom.name != "CoreControl") {
                    cr_Toggle = CreateToggle(cr_Bool, false);
                } else {
                    dm_button = CreateButton("Bring It to Player");
                    dm_button.buttonColor = new Color(0.66f, 0.60f, 0.69f);
                    dm_button.textColor = Color.white;
                }
                
                ts_Bool = new JSONStorableBool("Target Select after Add/Bring", true);
                RegisterBool(ts_Bool);
                if (containingAtom.name != "CoreControl") {
                    ts_Toggle = CreateToggle(ts_Bool, false);
                } else {
                    dm2_button = CreateButton("Target Select after Add/Bring");
                    dm2_button.buttonColor = new Color(0.66f, 0.60f, 0.69f);
                    dm2_button.textColor = Color.white;
                }

                filename = new JSONStorableString("AddAtomPreset Filename","Saves/PluginData/AddAtom/");
                RegisterString(filename);

                var loadPresetUI = CreateButton("Load Preset");
                loadPresetUI.button.onClick.AddListener(() => {
                    filename.val = "";
                    FileManagerSecure.CreateDirectory(presetLoadPath);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(presetLoadPath);
                    SuperController.singleton.GetMediaPathDialog(HandleLoadPreset, "json", presetLoadPath, false, true, false, null, false, shortcuts);
                });
                FileManagerSecure.CreateDirectory(presetLoadPath);

                col_button = CreateButton("Target Collision On");
                if (col_button != null) {
                    col_button.button.onClick.AddListener(collisionOn);
                }
                JSONStorableAction collisionOnAct = new JSONStorableAction("Target Collision On", () =>{collisionOn();});					
                RegisterAction(collisionOnAct);

                ja_Bool = new JSONStorableBool("Just Add", false);
                RegisterBool(ja_Bool);
                ja_Toggle = CreateToggle(ja_Bool, false);

                spacer = CreateSpacer(false);
                spacer.height = 5f;

                add_button = CreateButton("Add Atom");
                add_button.buttonColor = Color.green;
                if (add_button != null) {
                    add_button.button.onClick.AddListener(addAtom);
                }
                JSONStorableAction AddAtomAct = new JSONStorableAction("Add Atom", () =>{addAtom();});					
                RegisterAction(AddAtomAct);                

                kh_Bool = new JSONStorableBool("Keep Height", false);
                RegisterBool(kh_Bool);
                kh_Toggle = CreateToggle(kh_Bool, true);

                abp_Bool = new JSONStorableBool("Add/Move to Zero", false);
                RegisterBool(abp_Bool);
                abp_Toggle = CreateToggle(abp_Bool, true);

                mark_Bool = new JSONStorableBool("Show Marker", false);
                RegisterBool(mark_Bool);
                mark_Toggle = CreateToggle(mark_Bool, true);

				maxD = new JSONStorableFloat("Distance", 1f, 0f, 5f, true);
				smaxD = CreateSlider(maxD, true);
				RegisterFloat(maxD);

                spacer = CreateSpacer(true);
                spacer.height = 0f;

                bi_button = CreateButton("Bring It", true);
                bi_button.buttonColor = Color.green;
                if (bi_button != null) {
                    bi_button.button.onClick.AddListener(BringItNow);
                }
                JSONStorableAction BringItNowAct = new JSONStorableAction("Bring It", () =>{BringItNow();});					
                RegisterAction(BringItNowAct);

                spacer = CreateSpacer(true);
                spacer.height = 30f;

                mkArray();
                
                iniFile = "";
                var iniFileini = presetLoadPath + "/inifile.ini";
                if (FileManagerSecure.FileExists(iniFileini)) {
                    iniFile = SuperController.singleton.ReadFileIntoString(iniFileini);
                }
                
                if (iniFile.Trim() != "") {
                    iniFilePath = presetLoadPath + "/" + iniFile.Trim();
                    if (FileManagerSecure.FileExists(iniFilePath)) {
                        HandleLoadPreset(iniFilePath);
                    }
                }

                mkCatList();
                //SuperController.LogMessage($"{nameof(AddAtom)} initialized");
            }
            catch (Exception e) {
                SuperController.LogError($"{nameof(AddAtom)}.{nameof(Init)}: {e}");
            }
        }

        public void mkCatList() {
            if (dp1 != null) {RemovePopup(dp1);}
            if (dp2 != null) {RemovePopup(dp2);}
            if (spacer3 != null) {RemoveSpacer(spacer3);}
            if (rfl_button != null) {RemoveButton(rfl_button);}
            if (dp3 != null) {RemovePopup(dp3);}

            List<string> catChoices = new List<string>();
            foreach (string category in CatList) {
                catChoices.Add(category);
            }
            catJSON = new JSONStorableStringChooser("Category", catChoices, "None", "Category", SyncAtom);
            RegisterStringChooser(catJSON);
            dp1 = CreateScrollablePopup(catJSON, false);
            dp1.popupPanelHeight = 650f;          

            itemJSON = new JSONStorableStringChooser("Atom", null, "None", "Atom");
            RegisterStringChooser(itemJSON);
            dp2 = CreateScrollablePopup(itemJSON, false);
            dp2.popupPanelHeight = 550f;

            //spacer3 = CreateSpacer(true);
            //spacer3.height = 50f;

            rfl_button = CreateButton("Refresh List", true);
            if (rfl_button != null) {
                rfl_button.button.onClick.AddListener(refreshList);
            }
            JSONStorableAction refreshListAct = new JSONStorableAction("Refresh List", () =>{refreshList();});					
            RegisterAction(refreshListAct);
            mkList();
        }

		protected void SyncAtom(string category) {
            List<string> itemChoices = new List<string>();
            if (category != null) {
                if (catJSON.val != "None") {
                    var i = 0;
                    foreach (string dummy in CatList) {
                        if (category == AtomList[i][0]) {
                            foreach (string item in AtomList[i]) {
                                itemChoices.Add(item);
                            }
                        }
                    ++i;
                    }
                }
            itemChoices.RemoveAt(0);            
			itemJSON.choices = itemChoices;
			itemJSON.val = "None";
            }
        }

        public void addAtom() {
            SuperController.singleton.AddAtomByType(itemJSON.val, true, true, true);
            add = true;
            Invoke("BringItNow", 0.5f);              
        }
        
        public void BringItNow() {
			if (targetJSON.val != "None" || add == true) {
                if (add) {
                    targetAtom = SuperController.singleton.GetSelectedAtom();
                    AddedAtom = targetAtom;
                } else {
                    targetAtom = SuperController.singleton.GetAtomByUid(targetJSON.val);
                }

                targetAtomPosition = targetAtom.GetStorableByID("control").transform.position;
                if (cr_Bool.val) {
                    currentAtomPosition = SuperController.singleton.lookCamera.transform.position;
                } else {
                    currentAtomPosition = containingAtom.GetStorableByID("control").transform.position;
                }
                Vector3 targetDistance;
                targetDistance = targetAtomPosition - currentAtomPosition;

                if (!ja_Bool.val) {                
                    targetAtom.collisionEnabledJSON.val = false;
                    targetAtom.GetBoolJSONParam("on").val = false;                    
                    var maxDistance = Mathf.Max(Mathf.Abs(targetDistance.x), Mathf.Abs(targetDistance.y), Mathf.Abs(targetDistance.z));
                    if (maxDistance > maxD.val)
                    {
                        targetDistance.x = (targetDistance.x / maxDistance) * maxD.val;
                        targetDistance.y = (targetDistance.y / maxDistance) * maxD.val;
                        targetDistance.z = (targetDistance.z / maxDistance) * maxD.val;
                        targetAtom.GetStorableByID("control").transform.position = currentAtomPosition + targetDistance;
                    }

                    if (kh_Bool.val) {
                        kh = targetAtom.GetStorableByID("control").transform.position;
                        kh.y = targetAtomPosition.y;
                        targetAtom.GetStorableByID("control").transform.position = kh;
                    }
                    
                    if (abp_Bool.val) {
                        targetAtom.GetStorableByID("control").transform.position = Vector3.zero;
                    }
                }

                if (add) {
                    refreshList();
                    targetAtom = AddedAtom;
                    targetJSON.val = targetAtom.name;
                }
                Invoke("ReDisplay", 0.5f); 
            } 
        }

        public void refreshList() {
            RemovePopup(dp3);
            mkList();
        }

        public void ReDisplay() {
            targetAtom.GetBoolJSONParam("on").val = true;
            add = false;
            if (ts_Bool.val) {
                SuperController.singleton.SelectController(targetAtom.mainController);
            }  else {
                SuperController.singleton.SelectController(containingAtom.mainController);
            }
        }

        public void collisionOn() {
            if (targetJSON.val != "None") {
                targetAtom = SuperController.singleton.GetAtomByUid(targetJSON.val);
                targetAtom.collisionEnabledJSON.val = true;
            }
        }

        public void mkList() {
            // make atom selector
            List<string> targetChoices = new List<string>();
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs()) {
                targetAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (targetAtom.hidden == false && targetAtom.name != "[CameraRig]" && targetAtom.name != "CoreControl") {
                    targetChoices.Add(atomUID);
                } 
            }
            targetJSON = new JSONStorableStringChooser("Target", targetChoices, "None", "Target");
            RegisterStringChooser(targetJSON);
            dp3 = CreateScrollablePopup(targetJSON, true);
            dp3.popupPanelHeight = 550f;          
        }

        public void mkArray() {
            CatList = new List<string>(Items);

            AtomList.Add(new List<string>(new[] {
                "Animation",
                "AnimationPattern"
            }));

            AtomList.Add(new List<string>(new[] {
                "Force",
                "CycleForce",
                "GrabPoint",
                "RhythmForce",
                "SyncForce"
            }));
        
            AtomList.Add(new List<string>(new[] {
                "Light",
                "AptLamp",
                "AptOutdoorLight",
                "CyberpunkLight",
                "CyberpunkWallLight01",
                "CyberpunkWallLight02",
                "InvisibleLight",
                "ModernRoomLargeLamp",
                "TechnoLight",
                "TechnoLightBar+Light",
                "TechnoNeonCircle+Light",
                "TechnoNeonHeart+Light",
                "TechnoNeonSquare+Light",
                "TechnoNeonTriangle+Light",
                "TechnoRingLight+LIght",
                "Torch"
            }));
            
            AtomList.Add(new List<string>(new[] {
                "Misc",
                "CustomUnityAsset",
                "Empty",
                "WebBrowser",
                "WebPanel"
            }));
            
            AtomList.Add(new List<string>(new[] {
                "Toys",
                "Dildo",
                "Paddle",
                "ToyAH",
                "ToyBP"
            }));
            
            AtomList.Add(new List<string>(new[] {
                "Triggers",
                "Button",
                "CollisionTrigger",
                "LookAtTrigger",
                "UIButton",
                "UISlider",
                "UIToggle",
                "VariableTrigger"
            }));
        }

        private void HandleLoadPreset(string path) {
            string aJSON = SuperController.singleton.ReadFileIntoString(path);
            JSONNode jSONNode = JSON.Parse(aJSON);

            str1 = jSONNode["CatList"].AsArray.ToString().Replace("\"", "").Replace("[", "").Replace("]", "").Replace(" ", "");
            var arr1 = str1.Split(',');

            CatList = new List<string>(arr1);

            AtomList.Clear();                        
            str1 = jSONNode["AtomList"].AsArray.ToString().Replace("\"", "").Replace("[", "").Replace(" ", "");

            foreach (string dummy in CatList) {
                if (str1.IndexOf("],") != -1) {
                    str2 = str1.Substring(0, str1.IndexOf("],"));
                    str1 = str1.Substring(str1.IndexOf("],") + 2);
                } else {
                    str2 = str1.Substring(0, str1.Length - 2);
                }
                arr1 = str2.Split(',');
                AtomList.Add(new List<string>(arr1));
                //SuperController.LogMessage(str2);
                //SuperController.LogMessage(arr1.Count().ToString());
            }
            //SuperController.LogMessage("Count : " + AtomList.Count);
            mkCatList();
        }

        public void FixedUpdate() {
            if (sphere != null) {
                Destroy(sphere);
            }
            if (sphereG != null) {
                Destroy(sphereG);
            }
            if (line != null) {
                Destroy(line);
            }

            if (targetJSON.val != "None") {
                if (mark_Bool.val == true) {
                    if (sphere != null) {
                        Destroy(sphere);
                    }
                    if (sphereG != null) {
                        Destroy(sphereG);
                    }
                    if (line != null) {
                        Destroy(line);
                    }
                    targetAtom = SuperController.singleton.GetAtomByUid(targetJSON.val);
                    targetAtomPosition = targetAtom.GetStorableByID("control").transform.position;

                    sphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);
                    sphere.transform.position = targetAtomPosition;
                    sphere.GetComponent<MeshRenderer>().material.EnableKeyword("_EMISSION");
                    sphere.GetComponent<MeshRenderer>().material.SetColor("_EmissionColor", Color.magenta);
                    if (mkUpDown == true) {
                        mkSize += 0.03f;
                        if (mkSize >= 1.5f) {
                            mkUpDown =false;
                        } 
                    } else {
                        mkSize -= 0.03f;
                        if (mkSize <= 0.5f) {
                            mkUpDown = true;
                        }
                    }
                    sphere.transform.localScale = new Vector3(mkSize, mkSize, mkSize);
                    sphere.GetComponent<Collider>().isTrigger = true;

                    if (cr_Bool.val) {
                        currentAtomPosition = SuperController.singleton.lookCamera.transform.position;
                    } else {
                        currentAtomPosition = containingAtom.GetStorableByID("control").transform.position;
                    }

                    line = new GameObject();
                    var rd = line.AddComponent<LineRenderer>();
                        var positions = new Vector3[] {
                        currentAtomPosition,
                        targetAtomPosition
                    };
                    rd.startWidth = 0.01f;
                    rd.endWidth = 0.01f;
                    rd.SetPositions(positions);

                    Vector3 targetDistance;
                    targetDistance = targetAtomPosition - currentAtomPosition;
                    kh = targetAtomPosition;

                    if (!ja_Bool.val && !abp_Bool.val)
                    {
                        var maxDistance = Mathf.Max(Mathf.Abs(targetDistance.x), Mathf.Abs(targetDistance.y), Mathf.Abs(targetDistance.z));
                        if (maxDistance > maxD.val)
                        {
                            targetDistance.x = (targetDistance.x / maxDistance) * maxD.val;
                            targetDistance.y = (targetDistance.y / maxDistance) * maxD.val;
                            targetDistance.z = (targetDistance.z / maxDistance) * maxD.val;
                            targetAtomPosition = currentAtomPosition + targetDistance;
                        }
                        if (kh_Bool.val) {
                            targetAtomPosition.y = kh.y;
                        }
                    } else if (!ja_Bool.val && abp_Bool.val) {
                        targetAtomPosition = Vector3.zero;
                    }
                    sphereG = GameObject.CreatePrimitive(PrimitiveType.Sphere);
                    sphereG.transform.position = targetAtomPosition;
                    sphereG.GetComponent<MeshRenderer>().material.EnableKeyword("_EMISSION");
                    sphereG.GetComponent<MeshRenderer>().material.SetColor("_EmissionColor", Color.yellow);
                    sphereG.transform.localScale = new Vector3(0.2f, 0.2f, 0.2f);
                    sphereG.GetComponent<Collider>().isTrigger = true;
                }
            }
        }

        public void OnEnable() {
            try {
                //SuperController.LogMessage($"{nameof(AddAtom)} enabled");
            }
            catch (Exception e) {
                SuperController.LogError($"{nameof(AddAtom)}.{nameof(OnEnable)}: {e}");
            }
        }

        public void OnDisable() {
            try {
                if (sphere != null) {
                    Destroy(sphere);
                }
                if (sphereG != null) {
                    Destroy(sphereG);
                }
                if (line != null) {
                    Destroy(line);
                }
                //SuperController.LogMessage($"{nameof(AddAtom)} disabled");
            }
            catch (Exception e) {
                SuperController.LogError($"{nameof(AddAtom)}.{nameof(OnDisable)}: {e}");
            }
        }

        public void OnDestroy() {
            try {
                if (sphere != null) {
                    Destroy(sphere);
                }
                if (sphereG != null) {
                    Destroy(sphereG);
                }
                if (line != null) {
                    Destroy(line);
                }
                //SuperController.LogMessage($"{nameof(AddAtom)} destroyed");
            }
            catch (Exception e) {
                SuperController.LogError($"{nameof(AddAtom)}.{nameof(OnDestroy)}: {e}");
            }
        }
    }
}
